#
#
#
#
init_google = () ->
  root.gdata.data.table = new google.visualization.DataTable()

  for name,type of root.gdata.template
    root.gdata.data.table.addColumn(type, name )
    console.log("added column: #{name}")

#
#
#
#
setup_google_data = ()->
  #
  # get data for pie table
  root.gdata.data.pie = google.visualization.data.group(
    root.gdata.view.table,
    [3],
    [{'column': 3, 'aggregation': google.visualization.data.count, 'type': 'number'}]
  )
  #
  root.gdata.data.local_db = root.gdata.data.pie
  #
  root.gdata.data.org = google.visualization.data.group(
    root.gdata.view.table,
    [5,3],
    [{'column': 1, 'aggregation': google.visualization.data.count, 'type': 'number'}]
  )
  #
  root.gdata.data.query =google.visualization.data.group(
    root.gdata.view.table,
    [2,3],
    [{'column': 1, 'aggregation': google.visualization.data.count, 'type': 'number'}]
  )

setup_google_vis = () ->
  setup_google_vis_pie()
  setup_google_vis_query()
  setup_google_vis_org()
  setup_google_vis_table()

setup_google_vis_org = () ->
  el_id = 'table_organism'
  root.gdata.vis.org  = new google.visualization.Table(document.getElementById(el_id))
  root.gdata.view.org = build_table_for(root.gdata.data.org,el_id,"Organism")
  root.gdata.selection.list[el_id] = { view: root.gdata.view.org, vis: root.gdata.vis.org }
  root.gdata.vis.org.draw( root.gdata.view.org, { alternatingRowStyle: true})

setup_google_vis_query = () ->
  el_id = 'table_query'
  root.gdata.vis.query  = new google.visualization.Table(document.getElementById(el_id))
  root.gdata.view.query = build_table_for(root.gdata.data.query,el_id,"Query Term")
  root.gdata.selection.list[el_id] = { view: root.gdata.view.query, vis: root.gdata.vis.query }
  root.gdata.vis.query.draw( root.gdata.view.query, { alternatingRowStyle: true})


setup_google_vis_table = () ->
  root.gdata.vis.table = new google.visualization.Table(document.getElementById('table'))
  root.gdata.vis.table.draw(
    root.gdata.view.table, { alternatingRowStyle: true})

setup_google_vis_pie = () ->
  root.gdata.vis.pie = new google.visualization.ChartWrapper({
    chartType: 'PieChart'
    dataTable: root.gdata.data.pie
    options: {
      'title': 'Local Db x hits'
      'height': 500
    }
    containerId: 'pie_organism'
  })
  $('.select-all').css("display","inherit")
  draw_pie()

draw_pie = () ->
  root.gdata.vis.pie.draw() # actual draw of the pie

  google.visualization.events.addListener root.gdata.vis.pie, 'select', ()->
    selection = root.gdata.vis.pie.getChart().getSelection()
    for el,i in selection
      rowId = el.row
      rowName = root.gdata.vis.pie.eea.Lf[rowId].c[0].v
      if root.gdata.selection.pie[rowName] == undefined
        root.gdata.selection.pie[rowName] = {}
        root.gdata.selection.pie[rowName].show = true
      root.gdata.selection.pie[rowName].id   = rowId
      root.gdata.selection.pie[rowName].show = !root.gdata.selection.pie[rowName].show

    calcSlices(root.gdata.selection.pie)
    to_show = {}
    for el in root.gdata.data.local_db.Lf
      db_name = el.c[0].v
      if root.gdata.selection.pie[db_name] == undefined
        root.gdata.selection.pie[db_name] = {}
        root.gdata.selection.pie[db_name].show = true

      for key of root.gdata.selection.list
        if to_show[key] == undefined
          to_show[key] = []
        if root.gdata.selection.pie[db_name].show
          to_show[key].push root.gdata.selection[key][db_name]

    for key,value of to_show
      value.unshift(0) # adds first column
      root.gdata.selection.list[key].view.setColumns( value )
      root.gdata.selection.list[key].vis.draw( root.gdata.selection.list[key].view )

#
#
#
#
build_table_for = (data_table,element_id,name_1st_col) ->

  data_list = {}
  header = {} # will be used to find unique

  for el in data_table.Lf
    db_query = el.c[0].v
    db_name  = el.c[1].v
    db_count = el.c[2].v
    if data_list[db_query] == undefined
      data_list[db_query] = {}
    if data_list[db_query][db_name] == undefined
      data_list[db_query][db_name] = 0
    data_list[db_query][db_name] += db_count
    if header[db_name] == undefined
      header[db_name] = 1

  # general header for auxiliary tables
  new_data_table = new google.visualization.DataTable();
  new_data_table.addColumn("string", name_1st_col)
  root.gdata.selection[element_id] = {}
  for key of header
    idx = new_data_table.addColumn("number", key)
    root.gdata.selection[element_id][key] = idx

  # add rows
  for db_query of data_list
    my_data = [db_query]
    for db_name of header
      root.gdata.selection[db_name]
      if data_list[db_query][db_name] == undefined
        my_data.push 0 # empty
      else
        my_data.push( data_list[db_query][db_name] )
    new_data_table.addRow(my_data)
  #
  new google.visualization.DataView(new_data_table)
#
#
#
#
show_hide_table_entries = ()->
  if $('#table').is(":visible")
    to_show = []
    for el,idx in root.gdata.view.table.q.Lf
      row = el.c
      species = row[3].v
      if root.gdata.selection.pie[species] == undefined || root.gdata.selection.pie[species].show
        to_show.push(idx)
    root.gdata.view.table.setRows(to_show)
    root.gdata.vis.table.draw( root.gdata.view.table )


#
#
#
#
calcSlices = (selection) ->
  slices = {}
  maxSlices = root.gdata.vis.pie.eea.Lf.length
  for i in [0..(maxSlices-1)]
    slices["#{i}"] = {color: undefined}

  for key,value of selection
    if !value.show
      slices["#{value.id}"] = {color: "#aaa"}

  opt = root.gdata.vis.pie.getOptions()
  if opt.slices
    opt.slices = $.extend( opt.slices , slices )
  else
    opt.slices = slices
  #
  root.gdata.vis.pie.setOptions(opt)
  google.visualization.events.addOneTimeListener root.gdata.vis.pie, 'ready', ()->
    show_hide_table_entries()
  root.gdata.vis.pie.draw()
  #
